package resource

import (
  "testing"
  "github.com/stretchr/testify/assert"
  "decl/tests/mocks"
)

func TestNewResourceTypes(t *testing.T) {
  resourceTypes := NewTypes()
  assert.NotEqual(t, nil, resourceTypes)
}

func TestNewResourceTypesRegister(t *testing.T) {
  m := &mocks.MockResource {
    InjectLoadDecl: func(string) error { return nil },
    InjectApply: func() error { return nil },
  }

  resourceTypes := NewTypes()
  assert.NotEqual(t, nil, resourceTypes)
  
  resourceTypes.Register("foo", func() Resource { return m })

  r,e := resourceTypes.New("foo")
  assert.Equal(t, nil, e)
  assert.Equal(t, m, r)
}

func TestResourceTypesLoadResource(t *testing.T) {

}
